#ifndef CANVASVIEW_H
#define CANVASVIEW_H

#include <qcanvas.h>
#include <qvaluevector.h>
#include <qimage.h>
#include <valarray>

class QTimer;

class CanvasView : public QCanvasView {
	Q_OBJECT
	public:
		CanvasView(QWidget* parent = 0, const char* name = 0);
		void loadImage(const QString & filename);
		void saveImage();
		void closeImage();
		
		void commit();
		void rollback();
		void setFileName(const QString & filename);
	public slots:
		void applyCurve(std::valarray<int> curve);
	private slots:
		void processOneTile();
	private:
		QValueVector<QCanvasSprite*> m_sprites;
		QValueVector<QImage> m_tiles;
		QValueVector<QCanvasPixmapArray*> m_sequences;
		int m_tilesx;
		int m_tilesy;
		unsigned int m_tileToProcess;
		QTimer* m_tileTimer;
		std::valarray<int> m_lastTable;
		QSize m_imagesize;
		QString m_filename;
};

#endif
